/**
 * Apply the given decorator to all class methods
 *
 * @param decorator Method decorator to apply to all methods of a class
 * @param {string[]} options.exclude array of method names that won't be decorated
 * @param {boolean} options.deep if true, also decorates methods of the extended classes (recusrively)
 */
export declare const DecorateAll: (decorator: (target: any, propertyKey: string, descriptor?: PropertyDescriptor) => void, options?: {
    exclude?: string[];
    deep?: boolean;
}) => (target: any) => void;
