"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const decorate_all_decorator_1 = require("./decorate-all.decorator");
const AppendString = (mark) => {
    return (target, propertyKey, descriptor) => {
        const original = descriptor.value;
        descriptor.value = function (name) {
            return original.call(this, name + mark);
        };
    };
};
class Hello {
    constructor(message) {
        this.message = message;
    }
    a(name) {
        return this.message + name;
    }
    b(name) {
        return this.message + name;
    }
    c(name) {
        return this.message + name;
    }
}
let DecoratedHello = class DecoratedHello {
    constructor(message) {
        this.message = message;
    }
    a(name) {
        return this.message + name;
    }
    b(name) {
        return this.message + name;
    }
    c(name) {
        return this.message + name;
    }
};
DecoratedHello = __decorate([
    decorate_all_decorator_1.DecorateAll(AppendString('!')),
    __metadata("design:paramtypes", [String])
], DecoratedHello);
let ExtendedHello = class ExtendedHello extends Hello {
    c(name) {
        return this.message + name;
    }
};
ExtendedHello = __decorate([
    decorate_all_decorator_1.DecorateAll(AppendString('!'))
], ExtendedHello);
let DeepExtendedHello = class DeepExtendedHello extends Hello {
    c(name) {
        return this.message + name;
    }
};
DeepExtendedHello = __decorate([
    decorate_all_decorator_1.DecorateAll(AppendString('!'), { deep: true })
], DeepExtendedHello);
let DeepExtendedExcludedHello = class DeepExtendedExcludedHello extends Hello {
};
DeepExtendedExcludedHello = __decorate([
    decorate_all_decorator_1.DecorateAll(AppendString('?'), { deep: true, exclude: ['b'] })
], DeepExtendedExcludedHello);
let ExcludedHello = class ExcludedHello {
    constructor(message) {
        this.message = message;
    }
    a(name) {
        return this.message + name;
    }
    b(name) {
        return this.message + name;
    }
    c(name) {
        return this.message + name;
    }
};
ExcludedHello = __decorate([
    decorate_all_decorator_1.DecorateAll(AppendString('?'), { exclude: ['b'] }),
    __metadata("design:paramtypes", [String])
], ExcludedHello);
let ExtendedDecoratedHello = class ExtendedDecoratedHello extends ExtendedHello {
};
ExtendedDecoratedHello = __decorate([
    decorate_all_decorator_1.DecorateAll(AppendString('?'), { deep: true, exclude: ['b'] })
], ExtendedDecoratedHello);
describe('ApplyToAll', () => {
    it('decorates all methods', () => {
        const hello = new DecoratedHello('test');
        expect(hello.a('a')).toEqual('testa!');
        expect(hello.b('b')).toEqual('testb!');
        expect(hello.b('c')).toEqual('testc!');
    });
    it('does not decorate inherited methods when deep is false', () => {
        const hello = new ExtendedHello('test');
        expect(hello.a('a')).toEqual('testa');
        expect(hello.b('b')).toEqual('testb');
        expect(hello.c('c')).toEqual('testc!');
    });
    it('decorates inherited methods when deep is true', () => {
        const hello = new DeepExtendedHello('test');
        expect(hello.a('a')).toEqual('testa!');
        expect(hello.b('b')).toEqual('testb!');
        expect(hello.c('c')).toEqual('testc!');
    });
    it('leaves the base class intact', () => {
        const hello = new Hello('test');
        expect(hello.a('a')).toEqual('testa');
        expect(hello.b('b')).toEqual('testb');
        expect(hello.c('c')).toEqual('testc');
    });
    it('does not decorate excluded methods', () => {
        const hello = new ExcludedHello('test');
        expect(hello.a('a')).toEqual('testa?');
        expect(hello.b('b')).toEqual('testb');
        expect(hello.c('c')).toEqual('testc?');
    });
    it('does not decorate excluded inherited methods', () => {
        const hello = new DeepExtendedExcludedHello('test');
        expect(hello.a('a')).toEqual('testa?');
        expect(hello.b('b')).toEqual('testb');
        expect(hello.c('c')).toEqual('testc?');
    });
    it('preserves decorators on inherited methods', () => {
        const hello = new ExtendedDecoratedHello('test');
        expect(hello.a('a')).toEqual('testa?');
        expect(hello.b('b')).toEqual('testb');
        expect(hello.c('c')).toEqual('testc?!');
    });
});
